> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Set a user attribute for tenants (Beta)

POST https://api.sigmacomputing.com/v2/user-attributes/{userAttributeId}/tenants
Content-Type: application/json

Assign and set the value of a specific user attribute for one or more tenants.
  
  **Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

  ### Usage notes
  - Retrieve the **userAttributeId** by calling the [/v2/user-attributes](https://help.sigmacomputing.com/reference/list-user-attributes) endpoint.
  - Specify one or more tenant by tenantOrganizationId. Retrieve the **tenantOrganizationId** by calling the [/v2/tenants](https://help.sigmacomputing.com/reference/list-tenants) endpoint and using the `tenantOrganizationId` included in the response.
    

Reference: https://help.sigmacomputing.com/reference/set-user-attribute-for-tenants

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/user-attributes/{userAttributeId}/tenants:
    post:
      operationId: setUserAttributeForTenants
      summary: Set a user attribute for tenants (Beta)
      description: >-
        Assign and set the value of a specific user attribute for one or more
        tenants.
          
          **Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

          ### Usage notes
          - Retrieve the **userAttributeId** by calling the [/v2/user-attributes](https://help.sigmacomputing.com/reference/list-user-attributes) endpoint.
          - Specify one or more tenant by tenantOrganizationId. Retrieve the **tenantOrganizationId** by calling the [/v2/tenants](https://help.sigmacomputing.com/reference/list-tenants) endpoint and using the `tenantOrganizationId` included in the response.
            
      tags:
        - userAttributes
      parameters:
        - name: userAttributeId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/userAttributes_setUserAttributeForTenants_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                assignments:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItems
              required:
                - assignments
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValueType:
      type: string
      enum:
        - string
      description: Type of user attribute.
      title: >-
        V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValueType
    V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValue:
      type: object
      properties:
        val:
          type: string
          description: Value of the user attribute.
        type:
          $ref: >-
            #/components/schemas/V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValueType
          description: Type of user attribute.
      required:
        - val
        - type
      description: The value of the user attribute
      title: >-
        V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValue
    V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItems:
      type: object
      properties:
        tenantOrganizationId:
          type: string
          description: Unique identifier of the tenant.
        value:
          $ref: >-
            #/components/schemas/V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItemsValue
          description: The value of the user attribute
      required:
        - tenantOrganizationId
        - value
      title: >-
        V2UserAttributesUserAttributeIdTenantsPostRequestBodyContentApplicationJsonSchemaAssignmentsItems
    userAttributes_setUserAttributeForTenants_Response_200:
      type: object
      properties: {}
      title: userAttributes_setUserAttributeForTenants_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "assignments": [
    {
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000000",
      "value": {
        "val": "foo",
        "type": "string"
      }
    },
    {
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000001",
      "value": {
        "val": "bar",
        "type": "string"
      }
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python Request Example
import requests

url = "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants"

payload = { "assignments": [
        {
            "tenantOrganizationId": "00000000-0000-0000-0000-000000000000",
            "value": {
                "val": "foo",
                "type": "string"
            }
        },
        {
            "tenantOrganizationId": "00000000-0000-0000-0000-000000000001",
            "value": {
                "val": "bar",
                "type": "string"
            }
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Request Example
const url = 'https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"assignments":[{"tenantOrganizationId":"00000000-0000-0000-0000-000000000000","value":{"val":"foo","type":"string"}},{"tenantOrganizationId":"00000000-0000-0000-0000-000000000001","value":{"val":"bar","type":"string"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Request Example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants"

	payload := strings.NewReader("{\n  \"assignments\": [\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000000\",\n      \"value\": {\n        \"val\": \"foo\",\n        \"type\": \"string\"\n      }\n    },\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000001\",\n      \"value\": {\n        \"val\": \"bar\",\n        \"type\": \"string\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Request Example
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"assignments\": [\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000000\",\n      \"value\": {\n        \"val\": \"foo\",\n        \"type\": \"string\"\n      }\n    },\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000001\",\n      \"value\": {\n        \"val\": \"bar\",\n        \"type\": \"string\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Request Example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"assignments\": [\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000000\",\n      \"value\": {\n        \"val\": \"foo\",\n        \"type\": \"string\"\n      }\n    },\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000001\",\n      \"value\": {\n        \"val\": \"bar\",\n        \"type\": \"string\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php Request Example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants', [
  'body' => '{
  "assignments": [
    {
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000000",
      "value": {
        "val": "foo",
        "type": "string"
      }
    },
    {
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000001",
      "value": {
        "val": "bar",
        "type": "string"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Request Example
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"assignments\": [\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000000\",\n      \"value\": {\n        \"val\": \"foo\",\n        \"type\": \"string\"\n      }\n    },\n    {\n      \"tenantOrganizationId\": \"00000000-0000-0000-0000-000000000001\",\n      \"value\": {\n        \"val\": \"bar\",\n        \"type\": \"string\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Request Example
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["assignments": [
    [
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000000",
      "value": [
        "val": "foo",
        "type": "string"
      ]
    ],
    [
      "tenantOrganizationId": "00000000-0000-0000-0000-000000000001",
      "value": [
        "val": "bar",
        "type": "string"
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/tenants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```